aboutsummaryrefslogtreecommitdiffstats
path: root/tests/db-upgrade-0-1/t
diff options
context:
space:
mode:
authorGuilhem Moulin <guilhem@fripost.org>2019-11-13 06:24:07 +0100
committerGuilhem Moulin <guilhem@fripost.org>2019-11-13 06:24:07 +0100
commitc6bbdd8aa697b2d42be1ac0839189da32d437a8f (patch)
treecd1b8d19d99557fbebe33344d0d23f6ac826da57 /tests/db-upgrade-0-1/t
parent87d947df1b837514a0f1efa3bc36b58088bd2564 (diff)
parentdac4ab1c9306bf2035bc1547d2ed27ab09850120 (diff)
Merge branch 'master' into debian
Diffstat (limited to 'tests/db-upgrade-0-1/t')
-rw-r--r--tests/db-upgrade-0-1/t34
1 files changed, 34 insertions, 0 deletions
diff --git a/tests/db-upgrade-0-1/t b/tests/db-upgrade-0-1/t
new file mode 100644
index 0000000..088008e
--- /dev/null
+++ b/tests/db-upgrade-0-1/t
@@ -0,0 +1,34 @@
+# create the mailboxes from the database
+doveadm -u "local" mailbox create "a.b1.c1" "a.b1.c2" "a.b2.c" "a2"
+doveadm -u "remote" mailbox create "a.b1.c1" "a.b1.c2" "a.b2.c" "a2"
+
+# import an existing non-migrated database
+sqlite3 "$XDG_DATA_HOME/interimap/remote.db" <"$TESTDIR/before.sql" || error "Couldn't import DB"
+
+# migrate
+interimap || error "Couldn't upgrade DB"
+
+grep -Fx "Upgrading database version from 0" <"$STDERR" || error "Couldn't upgrade DB"
+check_mailboxes_status "a.b1.c1" "a.b1.c2" "a.b2.c" "a2"
+
+# verify that the new schema is as expected
+sqlite3 "$XDG_DATA_HOME/interimap/remote.db" >"$TMPDIR/dump.sql" <<-EOF
+ DELETE FROM local;
+ DELETE FROM remote;
+ .dump
+EOF
+
+# re-import and dump the expected dump to work around SQLite format
+# differences across versions
+sqlite3 "$XDG_DATA_HOME/interimap/remote2.db" <"$TESTDIR/after.sql"
+sqlite3 "$XDG_DATA_HOME/interimap/remote2.db" >"$TMPDIR/dump-expected.sql" <<-EOF
+ .dump
+EOF
+
+# XXX need 'user_version' PRAGMA in the dump for future migrations
+# http://sqlite.1065341.n5.nabble.com/dump-command-and-user-version-td101228.html
+diff -u --label="a/dump.sql" --label="b/dump.sql" \
+ "$TMPDIR/dump-expected.sql" "$TMPDIR/dump.sql" \
+ || error "DB dumps differ"
+
+# vim: set filetype=sh :